; Example of using playroutine 2

                processor 6502
                org 2048

getin           = $ffe4

start:          jsr initraster
                lda #22
                sta $d018
                lda #$00
                jsr $1000                       ;Initialize song 0
                ldx #$00
                lda #$20
clearscreen:    sta $0400,x
                sta $0500,x
                sta $0600,x
                sta $0700,x
                inx
                bne clearscreen
textloop:       lda text,x
                jsr convertascii
                sta $0400,x
                lda #$01
                sta $d800,x
                inx
                cpx #5*40
                bcc textloop
idle:           lda currraster
                ldx #52
                jsr printhex
                lda maxraster
                ldx #55
                jsr printhex
                jsr getin
                ldx #$0f
searchhex:      cmp hexnybble,x
                beq hexfound
                dex
                bpl searchhex
                cmp #"G"
                bcc idle
                cmp #"J"+1
                bcs idle
playsound:      sec
                sbc #"G"                        ;Sound effect number 0-3
                asl                             ;Convert into table-index
                tay
                lda sndtbl,y                    ;Lowbyte of sounddata address
                ldx sndtbl+1,y                  ;Highbyte of sounddata address
                ldy #$02                        ;Channel to play on (channel 3)
                jsr $1009                       ;Play sound!
                jmp idle
hexfound:       txa
                jsr $1006                       ;Set volume (0-F)
                jmp idle

printhex:       pha
                lsr
                lsr
                lsr
                lsr
                tay
                lda hexnybble,y
                jsr convertascii
                sta $0400,x
                pla
                and #$0f
                tay
                lda hexnybble,y
                jsr convertascii
                sta $0401,x
                rts

convertascii:   cmp #$60
                bcc ca_ok
                sbc #$60
ca_ok:          rts

initraster:     sei
                lda #<raster
                sta $0314
                lda #>raster
                sta $0315
                lda #50                         ;Set low bits of raster
                sta $d012                       ;position
                lda $d011
                and #$7f                        ;Set high bit of raster
                sta $d011                       ;position (0)
                lda #$7f                        ;Set timer interrupt off
                sta $dc0d
                lda #$01                        ;Set raster interrupt on
                sta $d01a
                lda $dc0d                       ;Acknowledge timer interrupt
                cli
                rts

raster:         nop
                nop
                nop
                nop
                nop
                nop
                nop
                lda $d012
                sta raster_cmp+1
                inc $d020
                jsr $1003                       ;Play music and measure
                lda $d012                       ;rastertime it took to
                dec $d020                       ;execute
                sec
raster_cmp:     sbc #$00
                sta currraster
                cmp maxraster
                bcc raster_skip
                sta maxraster
raster_skip:    dec $d019
                jmp $ea31

text:           dc.b "Example 2: Game-musicroutine            "
                dc.b "Rastertime:   /                         "
                dc.b "                                        "
                dc.b "Press 0-F to change volume.             "
                dc.b "Press G-J for sound effects.            "

hexnybble:      dc.b "0123456789ABCDEF"


sndtbl:         dc.w gunshot,explosion,arpeggio1,arpeggio2

gunshot:        include sfx_gun.s
explosion:      include sfx_expl.s
arpeggio1:      include sfx_arp1.s
arpeggio2:      include sfx_arp2.s

maxraster:      dc.b 0
currraster:     dc.b 0

                org $1000

                incbin example2.bin

